Package: groovy.xml.slurpersupport

## [Java] Class Attributes

- groovy.xml.slurpersupport.Attributes

-     public class Attributes
      extends NodeChildren

  Lazy evaluated representation of a node's attributes.

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class GPathResult` | `name, namespaceMap, namespacePrefix, namespaceTagHints, parent`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `Attributes(GPathResult parent, String name, String namespacePrefix, Map<String, String> namespaceTagHints)` Parameters: `parent` - the GPathResult prior to the application of the expression creating this GPathResult
    `Attributes(GPathResult parent, String name, Map<String, String> namespaceTagHints)` Parameters: `parent` - the GPathResult prior to the application of the expression creating this GPathResult

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `build(GroovyObject builder)` Builds this object into the supplied builder. Parameters: `builder` - the target builder
    `` | `public Iterator` | `childNodes()` Throws a `GroovyRuntimeException`, because attributes can have no children.
    `` | `public GPathResult` | `findAll(Closure closure)` Returns the children of this GPathResult matching the condition(s) specified in the passed closure. Parameters: `closure` - a closure to filters the children of this GPathResult Returns: the children matching the closure
    `` | `public Iterator` | `iterator()` {@inheritDoc}
    `` | `public List` | `list()` Creates a list of objects representing this GPathResult. Returns: a list representing of this GPathResult
    `` | `public String` | `name()` Returns the selected attribute name without the leading `@`.
    `` | `public Iterator` | `nodeIterator()` Returns the raw node iterator backing this lazy result. Returns: the underlying node iterator
    `` | `public GPathResult` | `parents()` Throws a `GroovyRuntimeException`, because it is not implemented yet.
    `` | `public String` | `text()` Returns the text of this GPathResult as a `String`. Returns: the text of this GPathResult
    `` | `public Writer` | `writeTo(Writer out)` Writes this object to the given writer. This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as it may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.) throws: IOException if an error occurred while outputting data to the writer Parameters: `out` - the Writer to which this Writable should output its data. Returns: the Writer that was passed

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class NodeChildren` | `appendNode, build, childNodes, find, findAll, iterator, nodeIterator, parents, replaceBody, replaceNode, size, text, writeTo`
    `class GPathResult` | `appendNode, breadthFirst, childNodes, children, createIterator, declareNamespace, depthFirst, equals, find, findAll, getAt, getAt, getBody, getProperty, hashCode, isEmpty, iterator, leftShift, list, lookupNamespace, name, nodeIterator, parent, parents, plus, plus, pop, putAt, replaceBody, replaceNode, setMetaClass, setProperty, size, text, toBigDecimal, toBigInteger, toBoolean, toDouble, toFloat, toInteger, toLong, toString, toURI, toURL`
    `class GroovyObjectSupport` | `getMetaClass, setMetaClass`

- - ### Constructor Detail

    - #### public Attributes(GPathResult parent, String name, String namespacePrefix, Map<String, String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `name` - if the GPathResult corresponds to something with a name, e.g. a node
        `namespacePrefix` - the namespace prefix if any
        `namespaceTagHints` - the known tag to namespace mappings

    - #### public Attributes(GPathResult parent, String name, Map<String, String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `name` - if the GPathResult corresponds to something with a name, e.g. a node
        `namespaceTagHints` - the known tag to namespace mappings

  - ### Method Detail

    - #### public void build(GroovyObject builder)

      Builds this object into the supplied builder.

      Parameters:
        `builder` - the target builder

    - #### public Iterator childNodes()

      Throws a `GroovyRuntimeException`, because attributes can have no children.

    - #### public GPathResult findAll(Closure closure)

      Returns the children of this GPathResult matching the condition(s) specified in the passed closure.

      Parameters:
        `closure` - a closure to filters the children of this GPathResult
      Returns:
        the children matching the closure

    - #### public Iterator iterator()

      {@inheritDoc}

    - #### public List list()

      Creates a list of objects representing this GPathResult.

      Returns:
        a list representing of this GPathResult

    - #### public String name()

      Returns the selected attribute name without the leading `@`.

    - #### public Iterator nodeIterator()

      Returns the raw node iterator backing this lazy result.

      Returns:
        the underlying node iterator

    - #### public GPathResult parents()

      Throws a `GroovyRuntimeException`, because it is not implemented yet.

    - #### public String text()

      Returns the text of this GPathResult as a `String`.

      Returns:
        the text of this GPathResult

    - #### public Writer writeTo(Writer out)

      Writes this object to the given writer.

      This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as it may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

      throws:
        IOException if an error occurred while outputting data to the writer
      Parameters:
        `out` - the Writer to which this Writable should output its data.
      Returns:
        the Writer that was passed